## unbound 1.6.7

=== doc/requirements.txt ===
Requirements for Recursive Caching Resolver 
	(a.k.a. Treeshrew, Unbound-C)
By W.C.A. Wijngaards, NLnet Labs, October 2006.

Contents
1. Introduction
2. History
3. Goals
4. Non-Goals


1. Introduction
---------------
This is the requirements document for a DNS name server and aims to
document the goals and non-goals of the project.  The DNS (the Domain
Name System) is a global, replicated database that uses a hierarchical
structure for queries.

Data in the DNS is stored in Resource Record sets (RR sets), and has a
time to live (TTL).  During this time the data can be cached.  It is
thus useful to cache data to speed up future lookups.  A server that
looks up data in the DNS for clients and caches previous answers to
speed up processing is called a caching, recursive nameserver.  

This project aims to develop such a nameserver in modular components, so
that also DNSSEC (secure DNS) validation and stub-resolvers (that do not
run as a server, but a linked into an application) are easily possible.

The main components are the Validator that validates the security
fingerprints on data sets, the Iterator that sends queries to the
hierarchical DNS servers that own the data and the Cache that stores
data from previous queries.  The networking and query management code
then interface with the modules to perform the necessary processing.

In Section 2 the origins of the Unbound project are documented. Section
3 lists the goals, while Section 4 lists the explicit non-goals of the
project. Section 5 discusses choices made during development.


2. History
----------
The unbound resolver project started by Bill Manning, David Blacka, and
Matt Larson (from the University of California and from Verisign), that
created a Java based prototype resolver called Unbound.  The basic
design decisions of clean modules was executed.

The Java prototype worked very well, with contributions from Geoff
Sisson and Roy Arends from Nominet.  Around 2006 the idea came to create
a full-fledged C implementation ready for deployed use.  NLnet Labs
volunteered to write this implementation.


3. Goals
--------
o A validating recursive DNS resolver.
o Code diversity in the DNS resolver monoculture.
o Drop-in replacement for BIND apart from config.
o DNSSEC support.
o Fully RFC compliant.
o High performance
	* even with validation.
o Used as
	* stub resolver.
	* full caching name server.
	* resolver library.
o Elegant design of validator, resolver, cache modules.
	* provide the ability to pick and choose modules.
o Robust.
o In C, open source: The BSD license. 
o Highly portable, targets include modern Unix systems, such as *BSD,
solaris, linux, and maybe also the windows platform.
o Smallest as possible component that does the job.
o Stub-zones can be configured (local data or AS112 zones).


4. Non-Goals
------------
o An authoritative name server.
o Too many Features.


5. Choices
----------
o rfc2181 discourages duplicates RRs in RRsets. unbound does not create
  duplicates, but when presented with duplicates on the wire from the
  authoritative servers, does not perform duplicate removal.
  It does do some rrsig duplicate removal, in the msgparser, for dnssec qtype
  rrsig and any, because of special rrsig processing in the msgparser.
o The harden-glue feature, when yes all out of zone glue is deleted, when
  no out of zone glue is used for further resolving, is more complicated 
  than that, see below.
  Main points:
  	* rfc2182 trust handling is used. 
	* data is let through only in very specific cases
	* spoofability remains possible.
  Not all glue is let through (despite the name of the option). Only glue 
  which is present in a delegation, of type A and AAAA, where the name is
  present in the NS record in the authority section is let through.
  The glue that is let through is stored in the cache (marked as 'from the
  additional section'). And will then be used for sending queries to. It
  will not be present in the reply to the client (if RD is off).
  A direct query for that name will attempt to get a msg into the message
  cache. Since A and AAAA queries are not synthesized by the unbound cache,
  this query will be (eventually) sent to the authoritative server and its
  answer will be put in the cache, marked as 'from the answer section' and
  thus remove the 'from the additional section' data, and this record is 
  returned to the client.
  The message has a TTL smaller or equal to the TTL of the answer RR.
  If the cache memory is low; the answer RR may be dropped, and a glue
  RR may be inserted, within the message TTL time, and thus return the
  spoofed glue to a client. When the message expires, it is refetched and
  the cached RR is updated with the correct content.
  The server can be spoofed by getting it to visit a especially prepared 
  domain. This domain then inserts an address for another authoritative 
  server into the cache, when visiting that other domain, this address may
  then be used to send queries to. And fake answers may be returned.
  If the other domain is signed by DNSSEC, the fakes will be detected.

  In summary, the harden glue feature presents a security risk if
  disabled. Disabling the feature leads to possible better performance
  as more glue is present for the recursive service to use. The feature
  is implemented so as to minimise the security risk, while trying to 
  keep this performance gain.
o The method by which dnssec-lameness is detected is not secure. DNSSEC lame
  is when a server has the zone in question, but lacks dnssec data, such as
  signatures. The method to detect dnssec lameness looks at nonvalidated 
  data from the parent of a zone. This can be used, by spoofing the parent,
  to create a false sense of dnssec-lameness in the child, or a false sense
  or dnssec-non-lameness in the child. The first results in the server marked
  lame, and not used for 900 seconds, and the second will result in a 
  validator failure (SERVFAIL again), when the query is validated later on.

  Concluding, a spoof of the parent delegation can be used for many cases
  of denial of service. I.e. a completely different NS set could be returned,
  or the information withheld. All of these alterations can be caught by
  the validator if the parent is signed, and result in 900 seconds bogus. 
  The dnssec-lameness detection is used to detect operator failures, 
  before the validator will properly verify the messages.

  Also for zones for which no chain of trust exists, but a DS is given by the
  parent, dnssec-lameness detection enables. This delivers dnssec to our 
  clients when possible (for client validators).

  The following issue needs to be resolved:
	a server that serves both a parent and child zone, where
	parent is signed, but child is not. The server must not be marked 
	lame for the parent zone, because the child answer is not signed. 
  Instead of a false positive, we want false negatives; failure to 
  detect dnssec-lameness is less of a problem than marking honest 
  servers lame. dnssec-lameness is a config error and deserves the trouble.
  So, only messages that identify the zone are used to mark the zone
  lame. The zone is identified by SOA or NS RRsets in the answer/auth.
  That includes almost all negative responses and also A, AAAA qtypes.
  That would be most responses from servers.
  For referrals, delegations that add a single label can be checked to be
  from their zone, this covers most delegation-centric zones.

  So possibly, for complicated setups, with multiple (parent-child) zones 
  on a server, dnssec-lameness detection does not work - no dnssec-lameness 
  is detected. Instead the zone that is dnssec-lame becomes bogus.

o authority features.
  This is a recursive server, and authority features are out of scope.
  However, some authority features are expected in a recursor. Things like
  localhost, reverse lookup for 127.0.0.1, or blocking AS112 traffic.
  Also redirection of domain names with fixed data is needed by service
  providers. Limited support is added specifically to address this.

  Adding full authority support, requires much more code, and more complex
  maintenance.

  The limited support allows adding some static data (for localhost and so),
  and to respond with a fixed rcode (NXDOMAIN) for domains (such as AS112).

  You can put authority data on a separate server, and set the server in 
  unbound.conf as stub for those zones, this allows clients to access data 
  from the server without making unbound authoritative for the zones.

o the access control denies queries before any other processing.
  This denies queries that are not authoritative, or version.bind, or any.
  And thus prevents cache-snooping (denied hosts cannot make non-recursive
  queries and get answers from the cache).

o If a client makes a query without RD bit, in the case of a returned 
  message from cache which is:
	answer section: empty
	auth section: NS record present, no SOA record, no DS record, 
		maybe NSEC or NSEC3 records present.
	additional: A records or other relevant records.
  A SOA record would indicate that this was a NODATA answer.
  A DS records would indicate a referral.
  Absence of NS record would indicate a NODATA answer as well.

  Then the receiver does not know whether this was a referral
  with attempt at no-DS proof) or a nodata answer with attempt
  at no-data proof. It could be determined by attempting to prove
  either condition; and looking if only one is valid, but both 
  proofs could be valid, or neither could be valid, which creates
  doubt. This case is validated by unbound as a 'referral' which
  ascertains that RRSIGs are OK (and not omitted), but does not
  check NSEC/NSEC3. 

o Case preservation
  Unbound preserves the casing received from authority servers as best 
  as possible. It compresses without case, so case can get lost there.
  The casing from the query name is used in preference to the casing
  of the authority server. This is the same as BIND. RFC4343 allows either 
  behaviour.
 
o Denial of service protection
  If many queries are made, and they are made to names for which the
  authority servers do not respond, then the requestlist for unbound
  fills up fast.  This results in denial of service for new queries.
  To combat this the first 50% of the requestlist can run to completion.
  The last 50% of the requestlist get (200 msec) at least and are replaced
  by newer queries when older (LIFO).
  When a new query comes in, and a place in the first 50% is available, this
  is preferred.  Otherwise, it can replace older queries out of the last 50%.
  Thus, even long queries get a 50% chance to be resolved.  And many 'short'
  one or two round-trip resolves can be done in the last 50% of the list.
  The timeout can be configured.

o EDNS fallback. Is done according to the EDNS RFC (and update draft-00).
  Unbound assumes EDNS 0 support for the first query.  Then it can detect
  support (if the servers replies) or non-support (on a NOTIMPL or FORMERR).
  Some middleboxes drop EDNS 0 queries, mainly when forwarding, not when
  routing packets.  To detect this, when timeouts keep happening, as the
  timeout approached 5-10 seconds, and EDNS status has not been detected yet,
  a single probe query is sent.  This probe has a sub-second timeout, and
  if the server responds (quickly) without EDNS, this is cached for 15 min.
  This works very well when detecting an address that you use much - like
  a forwarder address - which is where the middleboxes need to be detected.
  Otherwise, it results in a 5 second wait time before EDNS timeout is 
  detected, which is slow but it works at least. 
  It minimizes the chances of a dropped query making a (DNSSEC) EDNS server
  falsely EDNS-nonsupporting, and thus DNSSEC-bogus, works well with 
  middleboxes, and can detect the occasional authority that drops EDNS.
  For some boxes it is necessary to probe for every failing query, a

=== debian/changelog ===
unbound (1.6.7-1ubuntu2.6) bionic-security; urgency=medium

  * SECURITY UPDATE: Non-Responsive Delegation Attack
    - debian/patches/CVE-2022-3204.patch: limit number of lookups in
      iterator/iter_delegpt.*, iterator/iter_utils.*, iterator/iterator.c,
      services/cache/dns.c, services/mesh.*.
    - CVE-2022-3204

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 15 Nov 2022 15:07:17 -0500

unbound (1.6.7-1ubuntu2.5) bionic-security; urgency=medium

  * SECURITY UPDATE: Ghost domain names issues
    - debian/patches/CVE-2022-3069x-pre1.patch: fix that cachedb could
      return a partial CNAME chain in cachedb/cachedb.c,
      iterator/iterator.c, services/cache/dns.c, services/cache/dns.h.
    - debian/patches/CVE-2022-3069x-pre2.patch: backport a version of the
      iter_stub_fwd_no_cache function in iterator/iter_utils.c,
      iterator/iter_utils.h.
    - debian/patches/CVE-2022-3069x-pre3.patch: fix that nxdomain synthesis
      does not happen above the stub or forward definition in
      cachedb/cachedb.c, iterator/iter_utils.c, iterator/iter_utils.h,
      iterator/iterator.c, services/cache/dns.c, services/cache/dns.h.
    - debian/patches/CVE-2022-3069x.patch: fix the novel ghost domain
      issues in cachedb/cachedb.c, daemon/cachedump.c, daemon/worker.c,
      dns64/dns64.c, ipsecmod/ipsecmod.c, iterator/iter_utils.c,
      iterator/iter_utils.h, iterator/iterator.c, pythonmod/interface.i,
      pythonmod/pythonmod_utils.c, services/cache/dns.c,
      services/cache/dns.h, services/mesh.c,
      testdata/iter_prefetch_change.rpl, util/module.h,
      validator/validator.c.
    - CVE-2022-30698
    - CVE-2022-30699

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 04 Aug 2022 07:56:04 -0400

unbound (1.6.7-1ubuntu2.4) bionic-security; urgency=medium

  * SECURITY UPDATE: configuration injection via MITM
    - debian/patches/CVE-2019-25031.patch: use https, remove special
      characters in contrib/create_unbound_ad_servers.sh.
    - CVE-2019-25031
  * SECURITY UPDATE: integer overflows in the regional allocator
    - debian/patches/CVE-2019-25032.patch: fix overflows in config.h.in,
      configure, configure.ac, util/regional.c.
    - CVE-2019-25032
    - CVE-2019-25033
  * SECURITY UPDATE: integer overflow in sldns_str2wire_dname_buf_origin
    - debian/patches/CVE-2019-25034.patch: check lengths in
      sldns/str2wire.c.
    - CVE-2019-25034
  * SECURITY UPDATE: out-of-bounds write in sldns_bget_token_par
    - debian/patches/CVE-2019-25035.patch: check for space in
      sldns/parse.c.
    - CVE-2019-25035
  * SECURITY UPDATE: assertion failure and denial of service
    - debian/patches/CVE-2019-25036.patch: validate lengths in
      iterator/iter_scrub.c.
    - CVE-2019-25036
  * SECURITY UPDATE: assertion failure and denial of service
    - debian/patches/CVE-2019-25037.patch: validate length in
      util/data/dname.c.
    - CVE-2019-25037
  * SECURITY UPDATE: integer overflow in a size calculation
    - debian/patches/CVE-2019-25038.patch: check for overflows in
      dnscrypt/dnscrypt.c, respip/respip.c.
    - CVE-2019-25038
    - CVE-2019-25039
  * SECURITY UPDATE: infinite loop and assertion fail via compressed name
    - debian/patches/CVE-2019-25040.patch: validate compression pointers in
      util/data/dname.c.
    - CVE-2019-25040
    - CVE-2019-25041
  * SECURITY UPDATE: out-of-bounds write via a compressed name
    - debian/patches/CVE-2019-25042.patch: move assert in
      util/data/msgreply.c.
    - CVE-2019-25042
  * SECURITY UPDATE: incorrect PID file handling
    - debian/patches/CVE-2020-28935.patch: check for symlinks in
      daemon/unbound.c.
    - CVE-2020-28935
  * debian/patches: rename debian-changes to misc-changes.patch.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 05 May 2021 07:38:50 -0400

unbound (1.6.7-1ubuntu2.3) bionic-security; urgency=medium

  * SECURITY UPDATE: amplification attack and denial of service
    - debian/patches/CVE-2020-1226x.patch: fix iterator logic in
      iterator/iter_delegpt.c, iterator/iter_delegpt.h,
      iterator/iter_scrub.c, iterator/iter_utils.c, iterator/iterator.c,
      iterator/iterator.h, services/cache/dns.c, util/data/dname.c,
      util/data/msgparse.c.
    - CVE-2020-12263
    - CVE-2020-12264

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 22 May 2020 09:11:45 -0400

unbound (1.6.7-1ubuntu2.2) bionic; urgency=medium

  * d/p/lp-1788622-fix-systemd-reload.patch: Fix hang due to all worker threads
    stopping on reload (LP: #1788622)

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Mon, 27 Aug 2018 14:12:29 +0200

unbound (1.6.7-1ubuntu2.1) bionic-security; urgency=medium

  * SECURITY UPDATE: vulnerability in the processing of wildcard
    synthesized NSEC records (LP: #1773720)
    - debian/patches/CVE-2017-15105.patch
    - CVE-2017-15105

 -- Simon Deziel <simon@sdeziel.info>  Mon, 28 May 2018 02:38:19 +0000

unbound (1.6.7-1ubuntu2) bionic; urgency=medium

  * debian/apparmor-profile: add capabilities to chown/chmod Unix
    control socket and allow reading /var/lib/sss/mc/initgroups
    (Closes: #891705, LP: #1749931)

 -- Simon Deziel <simon@sdeziel.info>  Tue, 27 Feb 2018 21:31:49 -0500

unbound (1.6.7-1ubuntu1) bionic; urgency=medium

  * debian/apparmor: update to allow writing to /run/systemd/notify
    (Closes: #867186, LP: #1723900)

 -- Jamie Strandboge <jamie@ubuntu.com>  Thu, 22 Feb 2018 19:35:23 +0000

unbound (1.6.7-1build1) bionic; urgency=high

  * No change rebuild against openssl1.1.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 05 Feb 2018 23:29:28 +0000

unbound (1.6.7-1) unstable; urgency=medium

  * New upstream version 1.6.7

 -- Robert Edmonds <edmonds@debian.org>  Sun, 15 Oct 2017 17:46:46 -0400

unbound (1.6.6-1) unstable; urgency=medium

  * New upstream version 1.6.6
  * debian/control: Drop obsolete build-depends on dh-systemd
  * debian/control: Bump Standards-Version to 4.1.1 (no changes)



=== debian/control ===
Source: unbound
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian DNS Packaging <pkg-dns-devel@lists.alioth.debian.org>
Uploaders:
 Robert Edmonds <edmonds@debian.org>,
Build-Depends:
 autoconf,
 autotools-dev,
 bison,
 debhelper (>= 9.20160709),
 dh-apparmor <!pkg.unbound.libonly>,
 dh-autoreconf,
 dh-python <!pkg.unbound.libonly>,
 dpkg-dev (>= 1.16.1~),
 flex,
 libbsd-dev (>= 0.8.1~) [!linux-any],
 libevent-dev,
 libexpat1-dev,
 libfstrm-dev <!pkg.unbound.libonly>,
 libprotobuf-c-dev <!pkg.unbound.libonly>,
 libssl-dev <!pkg.unbound.libonly>,
 libsystemd-dev <!pkg.unbound.libonly>,
 libtool,
 nettle-dev,
 pkg-config,
 protobuf-c-compiler <!pkg.unbound.libonly>,
 python-dev:any (>= 2.6.6-3~) <!pkg.unbound.libonly>,
 libpython-dev (>= 2.6.6-3~) <!pkg.unbound.libonly>,
 python3-dev:any <!pkg.unbound.libonly>,
 libpython3-dev <!pkg.unbound.libonly>,
 swig <!pkg.unbound.libonly>,
Standards-Version: 4.1.1
Homepage: https://www.unbound.net/
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-dns/unbound.git
Vcs-Git: https://anonscm.debian.org/git/pkg-dns/unbound.git

Package: libunbound-dev
Section: libdevel
Architecture: any
Depends:
 libunbound2 (= ${binary:Version}),
 ${misc:Depends},
Multi-Arch: same
Description: static library, header files, and docs for libunbound
 Static library, header files, and documentation for libunbound.
 .
 libunbound performs and validates DNS lookups; it can be used to convert
 hostnames to IP addresses and back and obtain other information from the
 DNS. Cryptographic validation of results is performed with DNSSEC.

Package: libunbound2
Section: libs
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Multi-Arch: same
Description: library implementing DNS resolution and validation
 libunbound performs and validates DNS lookups; it can be used to convert
 hostnames to IP addresses and back and obtain other information from the
 DNS. Cryptographic validation of results is performed with DNSSEC.

Package: python-unbound
Section: python
Architecture: any
Depends:
 ${misc:Depends},
 ${python:Depends},
 ${shlibs:Depends},
Build-Profiles: <!pkg.unbound.libonly>
Description: library implementing DNS resolution and validation (Python bindings)
 Python extension module for libunbound.
 .
 libunbound performs and validates DNS lookups; it can be used to convert
 hostnames to IP addresses and back and obtain other information from the
 DNS. Cryptographic validation of results is performed with DNSSEC.

Package: python3-unbound
Section: python
Architecture: any
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Build-Profiles: <!pkg.unbound.libonly>
Description: library implementing DNS resolution and validation (Python3 bindings)
 Python3 extension module for libunbound.
 .
 libunbound performs and validates DNS lookups; it can be used to convert
 hostnames to IP addresses and back and obtain other information from the
 DNS. Cryptographic validation of results is performed with DNSSEC.

Package: unbound
Architecture: any
Depends:
 adduser,
 dns-root-data,
 lsb-base (>= 3.0-6),
 openssl,
 unbound-anchor,
 ${misc:Depends},
 ${shlibs:Depends},
Enhances:
 munin-node,
Suggests: apparmor
Build-Profiles: <!pkg.unbound.libonly>
Description: validating, recursive, caching DNS resolver
 Unbound is a recursive-only caching DNS server which can perform DNSSEC
 validation of results. It implements only a minimal amount of authoritative
 service to prevent leakage to the root nameservers: forward lookups for
 localhost, reverse for 127.0.0.1 and ::1, and NXDOMAIN for zones served by
 AS112. Stub and forward zones are supported.
 .
 This package contains the unbound daemon.

Package: unbound-anchor
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Replaces:
 unbound (<< 1.4.13-1),
Breaks:
 unbound (<< 1.4.13-1),
Build-Profiles: <!pkg.unbound.libonly>
Description: utility to securely fetch the root DNS trust anchor
 unbound-anchor is a utility which securely fetches or updates the root DNS
 zone trust anchor. A copy of the current root anchor and root update
 certificate is embedded in unbound-anchor. RFC 5011 trust anchor tracking is
 performed, with fallback to an SSL fetch if this fails.

Package: unbound-host
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Build-Profiles: <!pkg.unbound.libonly>
Description: reimplementation of the 'host' command
 This package provides the 'unbound-host' program that is bundled with the
 Unbound domain name server. This version differs from the one provided in the
 package called host, which is from NIKHEF, and bind9-host, which is from ISC,
 and has a similar but different set of features and options.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

ifneq ($(DEB_HOST_ARCH), amd64)
CONFIGURE_ARGS = --disable-flto
endif

ifneq ($(DEB_HOST_ARCH_OS), linux)
CONFIGURE_ARGS = --with-libbsd
endif

LIBRARY = libunbound2
DOPACKAGES = $(shell dh_listpackages)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

clean:
	dh_autotools-dev_restoreconfig
	dh_autoreconf_clean
	dh clean

build:
build-arch:
build-indep:

binary-arch: build
	dh_testdir
	dh_autoreconf
	dh_autotools-dev_updateconfig

ifneq (,$(filter unbound unbound-anchor unbound-host,$(DOPACKAGES)))
	# first build -- build unbound daemon
	PYTHON_VERSION="$(shell py3versions -vd)" \
	CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" LDFLAGS="-Wl,--as-needed $(LDFLAGS)" \
		dh_auto_configure -- \
		--disable-rpath \
		--with-pidfile=/run/unbound.pid \
		--with-rootkey-file=/var/lib/unbound/root.key \
		--with-libevent \
		--with-pythonmodule \
		--enable-subnet \
		--enable-dnstap \
		--enable-systemd \
		--with-dnstap-socket-path=/run/dnstap.sock \
		--libdir=/usr/lib \
		$(CONFIGURE_ARGS)
	$(MAKE)
	$(MAKE) install DESTDIR="$(CURDIR)/debian/tmp"
	$(MAKE) clean
endif

	# second build -- build libunbound only, against nettle
	CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" LDFLAGS="-Wl,--as-needed $(LDFLAGS)" \
		dh_auto_configure -- \
		--disable-rpath \
		--with-libunbound-only \
		--with-nettle \
		--with-rootkey-file=/var/lib/unbound/root.key \
		--with-libevent \
		--without-pythonmodule \
		--without-pyunbound \
		--enable-event-api \
		$(CONFIGURE_ARGS)
	$(MAKE)
	$(MAKE) install DESTDIR="$(CURDIR)/debian/tmp-lib"
	install -D -m 0644 contrib/libunbound.pc \
		$(CURDIR)/debian/libunbound-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/libunbound.pc
	$(MAKE) clean

ifneq (,$(filter python-unbound,$(DOPACKAGES)))
	# third build - pyunbound for Python 2
	PYTHON_VERSION="$(shell pyversions -vd)" \
	CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" LDFLAGS="-Wl,--as-needed $(LDFLAGS)" \
		dh_auto_configure -- \
		--disable-rpath \
		--with-pythonmodule \
		--with-pyunbound \
		$(CONFIGURE_ARGS)
	$(MAKE) _unbound.la
	install -D -m 0644 .libs/_unbound.so \
		debian/python-unbound/usr/lib/$(shell pyversions -d)/dist-packages/_unbound.so
	install -m 0644 \
		pythonmod/unboundmodule.py \
		libunbound/python/unbound.py \
		debian/python-unbound/usr/lib/$(shell pyversions -d)/dist-packages
	$(MAKE) clean
endif

ifneq (,$(filter python3-unbound,$(DOPACKAGES)))
	# fourth build - pyunbound for Python 3
	PYTHON_VERSION="$(shell py3versions -vd)" \
	CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" LDFLAGS="-Wl,--as-needed $(LDFLAGS)" \
		dh_auto_configure -- \
		--disable-rpath \
		--with-pythonmodule \
		--with-pyunbound \
		$(CONFIGURE_ARGS)
	$(MAKE) _unbound.la
	install -D -m 0644 .libs/_unbound.so \
		debian/python3-unbound/usr/lib/$(shell py3versions -d)/dist-packages/_unbound.so
	install -m 0644 \
		pythonmod/unboundmodule.py \
		libunbound/python/unbound.py \
		debian/python3-unbound/usr/lib/$(shell py3versions -d)/dist-packages
	$(MAKE) clean
endif

	dh_installdirs

ifneq (,$(filter unbound unbound-anchor unbound-host,$(DOPACKAGES)))
	dh_systemd_enable -p unbound
	dh_systemd_enable -p unbound --name=unbound-resolvconf
	dh_systemd_start -p unbound unbound.service

	dh_installinit --error-handler=true --restart-after-upgrade

	echo '$$named unbound' > debian/unbound/etc/insserv.conf.d/unbound
	install -m 0644 debian/resolvconf debian/unbound/etc/resolvconf/update.d/unbound
	install -m 0755 debian/resolvconf-package debian/unbound/usr/lib/resolvconf/dpkg-event.d/unbound
	install -m 0644 doc/example.conf debian/unbound/usr/share/doc/unbound/examples/unbound.conf
	install -m 0644 contrib/update-anchor.sh debian/unbound/usr/share/doc/unbound/contrib
	install -D -m 0755 contrib/unbound_munin_ debian/unbound/usr/share/munin/plugins/unbound_munin_
endif

	mkdir -p debian/libunbound-dev/usr/lib/$(DEB_HOST_MULTIARCH)
	mv \
		debian/tmp-lib/usr/lib/$(DEB_HOST_MULTIARCH)/libunbound.a \
		debian/tmp-lib/usr/lib/$(DEB_HOST_MULTIARCH)/libunbound.so \
		debian/libunbound-dev/usr/lib/$(DEB_HOST_MULTIARCH)

	mkdir -p debian/$(LIBRARY)/usr/lib/$(DEB_HOST_MULTIARCH)
	mv \
		debian/tmp-lib/usr/lib/$(DEB_HOST_MULTIARCH)/*.so.* \
		debian/$(LIBRARY)/usr/lib/$(DEB_HOST_MULTIARCH)
	chmod 0644 debian/$(LIBRARY)/usr/lib/$(DEB_HOST_MULTIARCH)/*

	dh_install
	dh_installchangelogs
	dh_installdocs
	dh_installman
ifneq (,$(filter python-unbound,$(DOPACKAGES)))
	dh_python2 --no-guessing-versions
endif
ifneq (,$(filter python3-unbound,$(DOPACKAGES)))
	dh_python3
endif
	dh_strip
	dh_compress -Xusr/share/doc/unbound/examples/unbound.conf

ifneq (,$(filter unbound unbound-anchor unbound-host,$(DOPACKAGES)))
	mkdir -p debian/unbound/etc/apparmor.d
	cp debian/apparmor-profile debian/unbound/etc/apparmor.d/usr.sbin.unbound
	dh_apparmor --profile-name=usr.sbin.unbound -punbound
endif

	dh_fixperms
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary-indep:
binary: binary-arch binary-indep

## unbound 1.7.3

=== debian/changelog ===
unbound (1.7.3-1build1) cosmic; urgency=high

  * No change rebuild against openssl 1.1.1 with TLS 1.3 support.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Sat, 29 Sep 2018 01:37:00 +0100

unbound (1.7.3-1) unstable; urgency=medium

  * New upstream version 1.7.3
    - Don't count CNAME response types received during qname minimisation as
      query restart. (Closes: #900800)

 -- Robert Edmonds <edmonds@debian.org>  Thu, 21 Jun 2018 12:45:09 -0400

unbound (1.7.2-1) unstable; urgency=medium

  [ Robert Edmonds ]
  * New upstream version 1.7.2
  * debian/control: Update Maintainer field (Closes: #899758)

  [ Vincent Bernat ]
  * daemon/daemon.c: Fix reload hangs with systemd (Closes: #892914)

 -- Robert Edmonds <edmonds@debian.org>  Wed, 20 Jun 2018 17:30:34 -0400

unbound (1.7.1-1) unstable; urgency=medium

  [ Robert Edmonds ]
  * debian/control: Update Vcs-* links to use salsa.debian.org URLs
  * New upstream version 1.7.1

  [ Simon Deziel ]
  * debian/apparmor-profile: Add capabilities to chown/chmod Unix control
    socket (Closes: #891705)
  * debian/apparmor-profile: Allow reading /var/lib/sss/mc/initgroups
  * debian/apparmor-profile: Permit unbound to notify readiness to systemd
    (Closes: #867186)
  * debian/apparmor-profile: Let unbound r/w anywhere under
    /var/lib/unbound (Closes: #882731)
  * debian/apparmor-profile: Use attach_disconnected

 -- Robert Edmonds <edmonds@debian.org>  Wed, 23 May 2018 15:41:54 -0400

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: net
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian DNS Packaging <pkg-dns-devel@lists.alioth.debian.org>
+XSBC-Original-Maintainer: unbound packagers <unbound@packages.debian.org>
 Uploaders:
  Robert Edmonds <edmonds@debian.org>,
 Build-Depends:
@@ -33,8 +33,8 @@
  swig <!pkg.unbound.libonly>,
 Standards-Version: 4.1.1
 Homepage: https://www.unbound.net/
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-dns/unbound.git
-Vcs-Git: https://anonscm.debian.org/git/pkg-dns/unbound.git
+Vcs-Browser: https://salsa.debian.org/dns-team/unbound
+Vcs-Git: https://salsa.debian.org/dns-team/unbound.git
 
 Package: libunbound-dev
 Section: libdevel

## unbound 1.9.0

=== debian/changelog ===
unbound (1.9.0-2ubuntu0.1) disco-security; urgency=medium

  * SECURITY UPDATE: Denial of service
    - debian/patches/CVE-2019-16866.diff: sets edns to zero
      to avoid access to an uninitialized memory in
      util/data/msgparse.c.
    - CVE-2019-16866

 -- Leonidas S. Barbosa <leo.barbosa@canonical.com>  Mon, 07 Oct 2019 14:49:35 -0300

unbound (1.9.0-2) unstable; urgency=medium

  [ Simon Deziel ]
  * Disable chroot'ing (Closes: #921538)

 -- Robert Edmonds <edmonds@debian.org>  Sat, 09 Feb 2019 21:10:52 -0500

unbound (1.9.0-1) unstable; urgency=medium

  * New upstream version 1.9.0
  * Team upload
  * Include dpkg/default.mk instead of only buildflags.mk
  * Update d/watch to reflect new download location and add signature check

 -- Ondřej Surý <ondrej@debian.org>  Tue, 05 Feb 2019 09:49:04 +0000

unbound (1.8.1-1) unstable; urgency=medium

  * New upstream version 1.8.1

 -- Robert Edmonds <edmonds@debian.org>  Thu, 08 Nov 2018 16:50:36 -0500

unbound (1.8.0-1) unstable; urgency=medium

  * New upstream version 1.8.0
  * debian/: libunbound2.symbols → libunbound8.symbols
  * debian/rules: libunbound2 → libunbound8
  * debian/control: libunbound2 → libunbound8
  * daemon/daemon.c: Fix systemd service manager state change notification

 -- Robert Edmonds <edmonds@debian.org>  Sat, 15 Sep 2018 16:21:11 -0400

=== debian/control ===
--- 
+++ 
@@ -40,7 +40,7 @@
 Section: libdevel
 Architecture: any
 Depends:
- libunbound2 (= ${binary:Version}),
+ libunbound8 (= ${binary:Version}),
  ${misc:Depends},
 Multi-Arch: same
 Description: static library, header files, and docs for libunbound
@@ -50,7 +50,7 @@
  hostnames to IP addresses and back and obtain other information from the
  DNS. Cryptographic validation of results is performed with DNSSEC.
 
-Package: libunbound2
+Package: libunbound8
 Section: libs
 Architecture: any
 Depends:

## unbound 1.9.0.1

=== debian/changelog ===
unbound (1.9.0.1-1+dde) unstable; urgency=low

  * ['Autobuild release-candidate: 3bf1d0e27653f8c27bbc490adde7a5f948df3e56']

 -- shuttle <shuttle@deepin.com>  Fri, 28 Aug 2020 14:47:25 +0000

## unbound 1.9.0.3

=== debian/changelog ===
unbound (1.9.0.3-1) unstable; urgency=medium

  * fix CVE-2019-25038 CVE-2019-25039

 -- Hu Qinghong <huqinghong@uniontech.com>  Mon, 05 Jul 2021 13:48:35 +0800

unbound (1.9.0.2-1+0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * fix CVE-2019-25034 CVE-2019-25035 CVE-2019-25042 CVE-2019-25036 CVE-2019-25037

 -- Hu Qinghong <huqinghong@uniontech.com>  Fri, 02 Jul 2021 16:05:54 +0800

unbound (1.9.0.1-1+dde) buster; urgency=medium

  * Non-maintainer upload.
  * fix CVE-2020-12662_12663

 -- zhouzilong <zhouzilong@uniontech.com>  Wed, 19 Aug 2020 18:18:39 +0800

unbound (1.9.0-2+deb10u1) buster-security; urgency=high

  * Apply NLnet Labs patch for CVE-2019-16866 (Closes: #941692)

 -- Robert Edmonds <edmonds@debian.org>  Sat, 12 Oct 2019 20:40:17 -0400

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: unbound
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: unbound packagers <unbound@packages.debian.org>
+Maintainer: unbound packagers <unbound@packages.debian.org>
 Uploaders:
  Robert Edmonds <edmonds@debian.org>,
 Build-Depends:

## unbound 1.9.0.4

=== debian/changelog ===
unbound (1.9.0.4-1+deepin) unstable; urgency=medium

  * fix CVE-2022-3204.

 -- liaoyuan <liaoyuan@uniontech.com>  Mon, 31 Oct 2022 00:47:27 +0800

## unbound 1.9.0.5

=== debian/changelog ===
unbound (1.9.0.5-deepin1) unstable; urgency=medium

  * Update  CVE-2020-12662 CVE-2020-12663 CVE-2022-3204
    patches and add them to debian/series.

 -- liaoyuan <liaoyuan@uniontech.com>  Tue, 22 Nov 2022 14:33:32 +0800

## unbound 1.9.3

=== debian/changelog ===
unbound (1.9.3-1~mx19+1) mx; urgency=medium

  * Rebuild for MX 19.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 20 Sep 2019 14:36:42 -0700

unbound (1.9.3-1) unstable; urgency=medium

  * New upstream version 1.9.3

 -- Robert Edmonds <edmonds@debian.org>  Tue, 27 Aug 2019 14:24:11 -0400

unbound (1.9.3~rc1-1) experimental; urgency=medium

  * New upstream version 1.9.3~rc1
  * debian/control: Bump Standards-Version to 4.4.0 (no changes)

 -- Robert Edmonds <edmonds@debian.org>  Sat, 17 Aug 2019 18:01:56 -0400

=== debian/rules ===
--- 
+++ 
@@ -11,12 +11,12 @@
 CONFIGURE_ARGS = --with-libbsd
 endif
 
-LIBRARY = libunbound2
+LIBRARY = libunbound8
 DOPACKAGES = $(shell dh_listpackages)
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 DPKG_EXPORT_BUILDFLAGS = 1
-include /usr/share/dpkg/buildflags.mk
+include /usr/share/dpkg/default.mk
 
 clean:
 	dh_autotools-dev_restoreconfig
@@ -45,6 +45,7 @@
 		--enable-subnet \
 		--enable-dnstap \
 		--enable-systemd \
+		--with-chroot-dir="" \
 		--with-dnstap-socket-path=/run/dnstap.sock \
 		--libdir=/usr/lib \
 		$(CONFIGURE_ARGS)
@@ -148,7 +149,7 @@
 ifneq (,$(filter python3-unbound,$(DOPACKAGES)))
 	dh_python3
 endif
-	dh_strip
+	dh_strip --no-automatic-dbgsym
 	dh_compress -Xusr/share/doc/unbound/examples/unbound.conf
 
 ifneq (,$(filter unbound unbound-anchor unbound-host,$(DOPACKAGES)))

## unbound 1.9.4

=== debian/changelog ===
unbound (1.9.4-2ubuntu1) focal; urgency=medium

  * Build-depend on python-all-dev.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 25 Jan 2020 11:43:33 +0100

unbound (1.9.4-2build1) focal; urgency=medium

  * No-change rebuild to build with python3.8.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 25 Jan 2020 04:41:11 +0000

unbound (1.9.4-2) unstable; urgency=medium

  * Cherry-pick upstream commit ec021e0d, "fix build with nettle-3.5"
    (Closes: #941041)

 -- Robert Edmonds <edmonds@debian.org>  Sat, 26 Oct 2019 08:00:58 -0400

unbound (1.9.4-1) unstable; urgency=high

  * New upstream version 1.9.4
    - Fix CVE-2019-16866: uninitialized memory access when parsing specially
      crafted NOTIFY query.

 -- Robert Edmonds <edmonds@debian.org>  Fri, 04 Oct 2019 00:43:19 -0400

=== debian/control ===
--- 
+++ 
@@ -25,12 +25,11 @@
  nettle-dev,
  pkg-config,
  protobuf-c-compiler <!pkg.unbound.libonly>,
- python-dev:any (>= 2.6.6-3~) <!pkg.unbound.libonly>,
- libpython-dev (>= 2.6.6-3~) <!pkg.unbound.libonly>,
+ python-all-dev:any (>= 2.6.6-3~) <!pkg.unbound.libonly>,
  python3-dev:any <!pkg.unbound.libonly>,
  libpython3-dev <!pkg.unbound.libonly>,
  swig <!pkg.unbound.libonly>,
-Standards-Version: 4.1.1
+Standards-Version: 4.4.0
 Homepage: https://www.unbound.net/
 Vcs-Browser: https://salsa.debian.org/dns-team/unbound
 Vcs-Git: https://salsa.debian.org/dns-team/unbound.git

## unbound 1.9.6

=== debian/changelog ===
unbound (1.9.6-2) unstable; urgency=medium

  * debian/unbound.maintscript: Remove obsolete conffile
    /etc/unbound/unbound.conf.d/qname-minimisation.conf (Closes: #950406)

 -- Robert Edmonds <edmonds@debian.org>  Sat, 01 Feb 2020 14:44:39 -0500

unbound (1.9.6-1) unstable; urgency=medium

  [ Robert Edmonds ]
  * New upstream version 1.9.6 (Closes: #948036)
    - Fixes 'unbound crashes with "Assertion nread >= 0 failed in
      evmap_io_del_"' (Closes: #930699)
    - Fixes "unbound: Fails to answer TCP queries due to broken idle-timeout"
      (Closes: #946421)
  * debian/source/options: Remove 'single-debian-patch' option
  * debian/unbound.service: Change ExecReload to send SIGHUP rather than
    using unbound-control (Closes: #923314)
  * Enable remote-control by default (Closes: #923314)
  * Allow use of libbsd functions with configure option --with-libbsd
  * Remove "qname-minimisation: yes" config file setting, since this is
    now the default (Closes: #915056)
  * debian/package-helper: No longer invoke unbound-anchor for root trust
    anchor update (Closes: #910675)
  * debian/control: Bump Standards-Version to 4.5.0 (no changes)
  * debian/control: Remove build dependencies on autotools-dev, dh-
    autoreconf
  * debian/libunbound8.symbols: Add "* Build-Depends-Package: libunbound-
    dev"
  * Rename debian/NEWS.Debian -> debian/NEWS

  [ Matthew Palmer ]
  * Fix insecure use of start-stop-daemon --pidfile (Closes: #941573)

  [ Simon Deziel ]
  * Install Apparmor profile prior to service startup (Closes: #919511)

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Drop use of autotools-dev debhelper.
  * Bump debhelper from old 9 to 10.
  * Set field Upstream-Name in debian/copyright.

 -- Robert Edmonds <edmonds@debian.org>  Sun, 26 Jan 2020 22:45:45 -0500

=== debian/control ===
--- 
+++ 
@@ -6,11 +6,9 @@
  Robert Edmonds <edmonds@debian.org>,
 Build-Depends:
  autoconf,
- autotools-dev,
  bison,
- debhelper (>= 9.20160709),
+ debhelper (>= 10~),
  dh-apparmor <!pkg.unbound.libonly>,
- dh-autoreconf,
  dh-python <!pkg.unbound.libonly>,
  dpkg-dev (>= 1.16.1~),
  flex,
@@ -25,11 +23,12 @@
  nettle-dev,
  pkg-config,
  protobuf-c-compiler <!pkg.unbound.libonly>,
- python-all-dev:any (>= 2.6.6-3~) <!pkg.unbound.libonly>,
+ python-dev:any (>= 2.6.6-3~) <!pkg.unbound.libonly>,
+ libpython-dev (>= 2.6.6-3~) <!pkg.unbound.libonly>,
  python3-dev:any <!pkg.unbound.libonly>,
  libpython3-dev <!pkg.unbound.libonly>,
  swig <!pkg.unbound.libonly>,
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
 Homepage: https://www.unbound.net/
 Vcs-Browser: https://salsa.debian.org/dns-team/unbound
 Vcs-Git: https://salsa.debian.org/dns-team/unbound.git

=== debian/rules ===
--- 
+++ 
@@ -19,7 +19,6 @@
 include /usr/share/dpkg/default.mk
 
 clean:
-	dh_autotools-dev_restoreconfig
 	dh_autoreconf_clean
 	dh clean
 
@@ -30,7 +29,6 @@
 binary-arch: build
 	dh_testdir
 	dh_autoreconf
-	dh_autotools-dev_updateconfig
 
 ifneq (,$(filter unbound unbound-anchor unbound-host,$(DOPACKAGES)))
 	# first build -- build unbound daemon
@@ -113,6 +111,10 @@
 	dh_installdirs
 
 ifneq (,$(filter unbound unbound-anchor unbound-host,$(DOPACKAGES)))
+	mkdir -p debian/unbound/etc/apparmor.d
+	cp debian/apparmor-profile debian/unbound/etc/apparmor.d/usr.sbin.unbound
+	dh_apparmor --profile-name=usr.sbin.unbound -punbound
+
 	dh_systemd_enable -p unbound
 	dh_systemd_enable -p unbound --name=unbound-resolvconf
 	dh_systemd_start -p unbound unbound.service
@@ -149,14 +151,8 @@
 ifneq (,$(filter python3-unbound,$(DOPACKAGES)))
 	dh_python3
 endif
-	dh_strip --no-automatic-dbgsym
+	dh_strip
 	dh_compress -Xusr/share/doc/unbound/examples/unbound.conf
-
-ifneq (,$(filter unbound unbound-anchor unbound-host,$(DOPACKAGES)))
-	mkdir -p debian/unbound/etc/apparmor.d
-	cp debian/apparmor-profile debian/unbound/etc/apparmor.d/usr.sbin.unbound
-	dh_apparmor --profile-name=usr.sbin.unbound -punbound
-endif
 
 	dh_fixperms
 	dh_makeshlibs

## unbound 1.11.0

=== debian/changelog ===
unbound (1.11.0-1) unstable; urgency=medium

  [ Simon Deziel ]
  * systemd: don't create a PID file
  * debian/package-helper: mount --bind systemd notify socket into chroot
    (Closes: #867187)

  [ Robert Edmonds ]
  * New upstream version 1.11.0
    - Merge PR #241 by Robert Edmonds: contrib/libunbound.pc.in: Do not use
      "Requires:". (Closes: #958331)
    - Introduce "include-toplevel:" configuration option.
    - Adds its own implementation of Frame Streams for dnstap support.
  * debian/control: Remove build dependency on libfstrm-dev
  * debian/unbound.conf: Use "include-toplevel:" instead of "include:"
    (Closes: #950754)
  * debian/NEWS: Add entry for 1.11.0-1 regarding the change of
    /etc/unbound/unbound.conf to using the "include-toplevel:" directive
  * debian/patches/: Refresh patches

 -- Robert Edmonds <edmonds@debian.org>  Sun, 09 Aug 2020 20:57:15 -0400

unbound (1.10.1-1) unstable; urgency=high

  * New upstream version 1.10.1
    - Fix CVE-2020-12662: Unbound can be tricked into amplifying an incoming
      query into a large number of queries directed to a target.
    - Fix CVE-2020-12663: Malformed answers from upstream name servers can be
      used to make Unbound unresponsive.

 -- Robert Edmonds <edmonds@debian.org>  Tue, 19 May 2020 11:36:53 -0400

unbound (1.10.0-1) unstable; urgency=medium

  [ Robert Edmonds ]
  * New upstream version 1.10.0
  * Drop debian/patches/0002-Allow-use-of-libbsd-functions-with-configure-
    option-.patch (applied upstream)

  [ Stuart Prescott ]
  * Drop Python 2 module package (Closes: #938752)

 -- Robert Edmonds <edmonds@debian.org>  Sat, 18 Apr 2020 19:29:50 -0400
